package pjv4;

import java.util.*;

class Sito {

    static HashSet sito(int max) {
        HashSet mnozina = new HashSet();
        for (int i = 2; i <= max; i++) {
            mnozina.add(new Integer(i));
        }
        int p = 2;
        int pmax = (int) Math.sqrt(max);
        do {
            // vypustit nasobky p
            for (int i = p * p; i <= max; i += p) {
                mnozina.remove(new Integer(i));
            }
            // hledani nejblizsiho k p
         //   vypis(mnozina, max);
            do {
                p++;
            } while (!mnozina.contains(new Integer(p)));
        } while (p <= pmax);
        return mnozina;
    }

    static void vypis(HashSet mnozina, int max) {
        for (int i = 2; i < max; i++) {
            if (mnozina.contains(new Integer(i))) {
                System.out.print(i + " ");
            }
        }
        System.out.println("");
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        System.out.println("zadejte max");
        int max = sc.nextInt();
        HashSet mnozina = sito(max);
        System.out.println("Množinou, prvočísla od 2 do " + max);
        vypis(mnozina, max);
    }
}
